<!--
    This component takes care of drawing the plotting frame and frame annotation,
    as well as setting up the clippign mask per SubplotGroup. The actual plot
    elements will be included in the slot.
-->
<script>
    import SubplotXAxis from './plot_frame_components/SubplotXAxis.svelte';
    import SubplotYAxis from './plot_frame_components/SubplotYAxis.svelte';
    import NowIndicator from './plot_frame_components/NowIndicator.svelte';
    import FrameLabel from './plot_frame_components/FrameLabel.svelte';
    import OptionalAnnotationBackground from './plot_frame_components/OptionalAnnotationBackground.svelte';
    import OptionalAnnotationForeground from './plot_frame_components/OptionalAnnotationForeground.svelte';
    import ColorLegend from './plot_components/ColorLegend.svelte';

    import { line, interpolateTurbo, scaleSequential } from 'd3';

    export let subplotLayout;
    export let xScale;
    let clip_path_id = "clip_subplot_" + subplotLayout.id;
    let clip_path_url = "url(#clip_subplot_" + subplotLayout.id + ")";
</script>

<g class={"subplot_" + subplotLayout.subplot_id}>
    <clipPath id={clip_path_id}>
        <rect width={xScale.range()[1]-xScale.range()[0]} height={subplotLayout.h} x={xScale.range()[0]} y={subplotLayout.y}/>
    </clipPath>
    {#if subplotLayout.annot_options}
        <OptionalAnnotationBackground {subplotLayout} {xScale} {clip_path_url}/>
    {/if}
    <g class="plot_elements" clip-path={clip_path_url}>
        <slot/>
    </g>
    <SubplotXAxis {subplotLayout} {xScale}/>
    <SubplotYAxis {subplotLayout} {xScale}/>
    {#if subplotLayout.annot_options}
        <OptionalAnnotationForeground {subplotLayout} {xScale} {clip_path_url}/>
    {/if}

    {#each subplotLayout.plot_elements as plot_elem}
        {#if plot_elem.plot_options.color_scale_domain}
            <ColorLegend color={scaleSequential([plot_elem.plot_options.color_scale_domain.default[0], plot_elem.plot_options.color_scale_domain.default[1]], interpolateTurbo)} {subplotLayout} {xScale} title={plot_elem.plot_options.color_scale_label}/>
        {/if}
    {/each}

    <NowIndicator {xScale} y1={subplotLayout.y} y2={subplotLayout.y+subplotLayout.h} {clip_path_url}/>
    <FrameLabel {subplotLayout} {xScale}/>
</g>

<style>
</style>
